package com.yunan.response;

public class Result {
    private int code;       // 状态码，200代表成功，其他代表失败
    private String message; // 响应信息
    private Object data;    // 响应数据

    // 默认构造函数
    public Result() {
    }

    // 构造函数
    public Result(int code, String message, Object data) {
        this.code = code;
        this.message = message;
        this.data = data;
    }

    // 成功返回
    public static Result ok(Object data) {
        return new Result(200, "成功", data); // 200代表成功
    }

    // 错误返回
    public static Result error(String message) {
        return new Result(500, message, null); // 500代表服务器错误，message为错误信息
    }

    // 错误返回，带code和message
    public static Result error(int code, String message) {
        return new Result(code, message, null); // 根据传入的code返回不同的错误
    }

    // get 和 set 方法
    public int getCode() {
        return code;
    }

    public void setCode(int code) {
        this.code = code;
    }

    public String getMessage() {
        return message;
    }

    public void setMessage(String message) {
        this.message = message;
    }

    public Object getData() {
        return data;
    }

    public void setData(Object data) {
        this.data = data;
    }

    // 重写toString方法，方便调试输出
    @Override
    public String toString() {
        return "Result{" +
                "code=" + code +
                ", message='" + message + '\'' +
                ", data=" + data +
                '}';
    }
}
